#include <iostream>

class A {
    int ma;  // questo è un membro privato

protected:
    int mb;  // questo è un membro protetto

public:
    int mc;  // questo è un membro pubblico

    A(): A(0, 1, 2) {}

    A(int a, int b, int c): ma{a}, mb{b}, mc{c}
    {}

    friend std::ostream& operator<<(std::ostream& os, const A& a)
    {
        os << "A(" << a.ma
           << "," << a.mb
           << "," << a.mc
           << ")";

        return os;
    }
};

class B : public A {
    int md;  // questo è un membro privato
public:
    B(): A(3,2,1), md{0}
    {}

    friend std::ostream& operator<<(std::ostream& os, const B& b)
    {
        // b.ma   // ERRORE: get_ma() è privato in A
        os << "B(" 
           << dynamic_cast<const A&>(b) << "," 
           << b.md << ")";

        return os;
    }
};

int main()
{
    A a;
    std::cout << a << std::endl;

    B b;
    std::cout << b << std::endl;

    return 0;
}